# 148574B Kaito Tokumori
# phase change program

import numpy as np
from scipy import fftpack
import pylab as plt
from PIL import Image
import matplotlib.cm as cm

img1 = Image.open('./img1.png').convert('L')
img2 = Image.open('./img2.png').convert('L')
img1array = np.asarray(img1)
img2array = np.asarray(img2)

plt.subplot(2,2,1)
plt.title('original1')
plt.imshow(img1array, cmap = cm.Greys_r)
plt.subplot(2,2,2)
plt.title('original2')
plt.imshow(img2array, cmap = cm.Greys_r)

fft_img1 = fftpack.fft2(img1array, axes=(0,1))
fft_img2 = fftpack.fft2(img2array, axes=(0,1))

abs1 = np.abs(fft_img1)
abs2 = np.abs(fft_img2)

phase1 = np.angle(fft_img1)
phase2 = np.angle(fft_img2)

new_fft1 = abs1 * np.exp(1j*phase2)
new_img1 = fftpack.ifft2(new_fft1, axes=(0,1)).real
plt.subplot(2,2,3)
plt.title('changed1')
plt.imshow(new_img1, cmap = cm.Greys_r)

new_fft2 = abs2 * np.exp(1j*phase1)
new_img2 = fftpack.ifft2(new_fft2, axes=(0,1)).real
plt.subplot(2,2,4)
plt.title('changed2')
plt.imshow(new_img2, cmap = cm.Greys_r)

plt.show()
